from typing import List

from pydantic import Field

from .base_model import BaseModel
from .enums import SourceState
from .fragments import ErrorDetails


class StartSource(BaseModel):
    source_start: "StartSourceSourceStart" = Field(alias="sourceStart")


class StartSourceSourceStart(BaseModel):
    errors: List["StartSourceSourceStartErrors"]
    state: SourceState


class StartSourceSourceStartErrors(ErrorDetails):
    pass


StartSource.update_forward_refs()
StartSourceSourceStart.update_forward_refs()
StartSourceSourceStartErrors.update_forward_refs()
